力扣-三数之和

[复制链接]
发表于 2025-8-10 17:00:07 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
1.题目形貌


2.题目链接

LCR 007. 三数之和 - 力扣(LeetCode) 

3.题目代码

  1. import java.util.*;
  2. class Solution {
  3.     public List<List<Integer>> threeSum(int[] nums) {
  4.         Arrays.sort(nums);
  5.         int temp=nums.length-1;
  6.         Set<List<Integer>> set=new HashSet<>();
  7.         while(temp>1){
  8.             int left=0,right=temp-1;
  9.             while(left<right){
  10.                 if(nums[left]+nums[right]+nums[temp]==0){
  11.                     List<Integer> row=Arrays.asList(nums[left],nums[right],nums[temp]);
  12.                     set.add(row);
  13.                     left++;right--;
  14.                 }
  15.                 else if(nums[left]+nums[right]+nums[temp]>0){
  16.                     right--;
  17.                 }else{
  18.                     left++;
  19.                 }
  20.             }
  21.             temp--;
  22.         }
  23.         return new ArrayList<>(set);
  24.     }
  25. }
复制代码
4.解题思路

这道题我们用的依然还是双指针+定数指针的解题思路,和前面我记录的有效三角形的个数的OJ题目一样,只必要界说定数指针在数组的最后一个元素上,再在剩余数组的边界界说两个指针,根据单调性来进行指针的移动即可。
5.代码细节

1)类型转换

由于我们为了方便去重,界说的是set,而题目中的泛型要求我们返回List<List<Integer>>,所以我们在界说完set之后:
  1. Set<List<Integer>> set = new HashSet<>();
复制代码
还必要在最后转换类型:
  1. return new ArrayList<>(set);
复制代码
2)构造动态三元组

创建动态列表存储三元组:
  1. List<Integer> row=Arrays.asList(nums[left],nums[right],nums[temp]);
复制代码
3)找到三元组后的指针移动逻辑

在找到1个三元组而且存入set后,我们必要移动双指针:left--,right++。
为什么呢?
由于我们必要探求下一个符合条件的三元组,也就是探求下一个满足nums[left]+nums[right]+nums[temp]==0的三元组,但是假如移动单个指针,等式的平衡会被冲破,左边肯定不会等于右边,只有同时移动双指针,才有可能重新满足不等式。


回复

使用道具 举报

登录后关闭弹窗

登录参与点评抽奖  加入IT实名职场社区
去登录
快速回复 返回顶部 返回列表